<template>
  <div class="w-full h-full flex flex-col justify-center items-center">
    <TasksView />
  </div>
</template>

<script>
import Project from '~/classes/Project'
import WorkCategory from '~/classes/WorkCategory'
import { getAxiosHeaders } from '~/utils/utils'
import TasksView from '~/view/Tasks.vue'
export default {
  name: 'HomePage',
  components: {
    TasksView,
  },
  mounted() {
    this.loadWorkCategories()
    this.loadProjects()
  },
  methods: {
    async loadWorkCategories() {
      try {
        await this.$axios
          .$get('getAllCategories', getAxiosHeaders(this.$auth))
          .then((response) => {
            if (response.status.is_error) {
              return this.$toast.error(
                'Ocorreu um erro ao carregar as categorias de trabalho, contate um administrador.',
                {
                  closeOnSwipe: true,
                  duration: 3000,
                }
              )
            }
            const workCategories = response.data.workCategories.map(
              (category) => new WorkCategory({ ...category })
            )
            this.$store.commit(
              'workCategories/loadWorkCategories',
              workCategories
            )
          })
      } catch (error) {
        // eslint-disable-next-line no-console
        console.warn(error)
        this.$toast.error('Ocorreu um erro inesperado...', {
          closeOnSwipe: true,
          duration: 2000,
        })
      }
    },
    async loadProjects() {
      try {
        await this.$axios
          .$get('getAllProjects', getAxiosHeaders(this.$auth))
          .then((response) => {
            if (response.status.is_error) {
              return this.$toast.error(
                'Ocorreu um erro ao carregar projetos, contate um administrador.',
                {
                  closeOnSwipe: true,
                  duration: 3000,
                }
              )
            }
            const projects = response.data.projects.map(
              (project) => new Project({ ...project })
            )
            this.$store.commit('projects/loadProjects', projects)
          })
      } catch (error) {
        // eslint-disable-next-line no-console
        console.warn(error)
        this.$toast.error('Ocorreu um erro inesperado...', {
          closeOnSwipe: true,
          duration: 2000,
        })
      }
    },
  },
}
</script>
